/*

Sppong 0.2: An example of using SDL with the SDL_image, SDL_ttf and SDL_mixer libraries..
Copyright (C) 2010-2012 Issam Abdallah

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Issam Abdallah, Tunisia
iabdallah@iissam.com

*/

# include "defs.h"
#define VOLUME 100	/* Volume 0..128 */

SDL_Surface *screen   = NULL;
SDL_Surface *surface  = NULL;
SDL_Surface *table    = NULL;
SDL_Surface *center   = NULL;

SDL_Surface *leftlm1  = NULL;
SDL_Surface *leftlm2  = NULL;
SDL_Surface *leftlm3  = NULL;

SDL_Surface *rightlm1 = NULL;
SDL_Surface *rightlm2 = NULL;
SDL_Surface *rightlm3 = NULL;

SDL_Surface *top1 = NULL;
SDL_Surface *top2 = NULL;

SDL_Surface *bas1 = NULL;
SDL_Surface *bas2 = NULL;

SDL_Surface *rack1   = NULL;
SDL_Surface *rack2   = NULL;
SDL_Surface *ball    = NULL;

SDL_Surface *time    = NULL;
SDL_Surface *score   = NULL;
SDL_Surface *title   = NULL;     
TTF_Font *police = NULL;

Mix_Chunk * mur = NULL;
Mix_Chunk * hit = NULL;

int main(int argc, char *argv[])
{
 
 SDL_Event event;
 SDL_Thread *thread1, *thread2;
 play = 1;
 char buffer[32] = "ready ?";
 char sbuffer[32];

/* 
 int i;
 for(i=0;i<argc;i++)
	printf(" %s\n",argv[i]); 
*/

/***************************** 
 * Establishing the connexion *****************************************
 **********************************************************************
/
/* Open a server socket */
client_size = sizeof(client);

printf("Configuring the connection ...\n");        
ssock = socket(AF_INET, SOCK_STREAM, 0); 							
     
if (ssock < 0)
{
 perror("socket");
 exit(EXIT_FAILURE);
}
else
{
 /* Setting the address (port + IP @) of the server socket */
 server.sin_addr.s_addr    = inet_addr("127.0.0.1"/*"192.168.1.7"*/);   /* IP @ of the server */ 
 server.sin_family         = AF_INET;                  			/* Address format that goes with the internet mamespace (domain) */ 
 server.sin_port           = htons(23);                			/* Port number : telnet protocol */            
                
 /* Assigning the adress to the server socket */
 printf("Binding the adress to the server (player1) socket...\n");

 if(bind(ssock, (struct sockaddr*)&server, sizeof(server)) < 0)
 {
  perror("bind");
  exit(EXIT_FAILURE);
 }           	   
 else
 {         
  printf("Establishing the connection ...\n");
          
  if(listen(ssock, 1) < 0)
  {
   perror("listen");
   exit(EXIT_FAILURE);
  } 
  else
  {
   printf("Waiting for player 2 to connect ...\n");        
            
   csock = accept(ssock, (struct sockaddr*)&client, &client_size);
   if(csock == -1)
   {
    printf("No connection request ...\n");
    exit(EXIT_FAILURE);
   }
   else
   {
    printf("Player 2 try to connect ...\n");
    printf("Connection request accepted ...\n");
    printf("Testing the connexion ...\n");
      
    if(send(csock, buffer, 32, 0) == -1)
    {
     perror("send");
     exit(EXIT_FAILURE);
    }
    else
    {
     printf("send message : %s\n",buffer);

     if(recv(csock, sbuffer, 32, 0) == -1)
     {
      perror("recv");
      exit(EXIT_FAILURE);
     }
     else
     {
      printf("received message : %s\n", sbuffer);
      printf("The connection was tested succefully ...\n");  
     }
    }
   }         
  }
 }
}
/* initialisation of SDL */
  if( SDL_Init(SDL_INIT_TIMER | SDL_INIT_VIDEO | SDL_INIT_AUDIO) == -1)
    {
	fprintf(stderr, "SDL_Init Error : %s\n", SDL_GetError());
	exit(0);
 	}

/* initialisation of SDL_ttf */
  if(TTF_Init() == -1)
    {
	fprintf(stderr, "TTF_Init Error : %s\n", TTF_GetError());
	exit(0);
	}
/* initialisation of SDL_mixer */
  if(Mix_Init(0) == -1)
    {
	fprintf(stderr, "TTF_Init Error : %s\n", Mix_GetError());
	exit(0);
	}

/* screen */
screen   = SDL_SetVideoMode(660, 700, BitPixel, SDL_HWSURFACE | SDL_DOUBLEBUF /*| SDL_FULLSCREEN*/);
surface  = SDL_CreateRGBSurface(SDL_HWSURFACE, 640, screen->h -60, BitPixel, 0, 0, 0, 0);
table    = SDL_CreateRGBSurface(SDL_HWSURFACE, 640, 30,  BitPixel, 0, 0, 0, 0);
center   = SDL_CreateRGBSurface(SDL_HWSURFACE, surface->w, 1,BitPixel, 0, 0, 0, 0);

leftlm1  = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 50,  BitPixel, 0, 0, 0, 0);
leftlm2  = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 100, BitPixel, 0, 0, 0, 0);
leftlm3  = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 50,  BitPixel, 0, 0, 0, 0);
rightlm1 = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 50,  BitPixel, 0, 0, 0, 0);
rightlm2 = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 100, BitPixel, 0, 0, 0, 0);
rightlm3 = SDL_CreateRGBSurface(SDL_HWSURFACE, 1, 50,  BitPixel, 0, 0, 0, 0);

bas1 = SDL_CreateRGBSurface(SDL_HWSURFACE, 50, 1,  BitPixel, 0, 0, 0, 0);
bas2 = SDL_CreateRGBSurface(SDL_HWSURFACE, 50, 1,  BitPixel, 0, 0, 0, 0);
top1 = SDL_CreateRGBSurface(SDL_HWSURFACE, 50, 1,  BitPixel, 0, 0, 0, 0);
top2 = SDL_CreateRGBSurface(SDL_HWSURFACE, 50, 1,  BitPixel, 0, 0, 0, 0);

/* Images */
ball  = IMG_Load("data/ball.png");
rack1 = IMG_Load("data/rack.png");
rack2 = IMG_Load("data/rack.png");

/* police */
police = TTF_OpenFont("data/digital.ttf", 20);

/* sound */
Mix_OpenAudio(22050, AUDIO_U8, 1, 512);

hit = Mix_LoadWAV("data/hit.wav");
mur = Mix_LoadWAV("data/mur.wav");

Mix_VolumeChunk(hit, VOLUME);
Mix_VolumeChunk(mur, VOLUME);

/* surface position */
 positionSur.x = screen->w/2 - surface->w/2; 
 positionSur.y = 50;

 positionTab.x = screen->w/2 - table->w/2;
 positionTab.y = 10;

 positionCtr.x = 0;
 positionCtr.y = surface->h/2;

 positionRg1.x = 0;
 positionRg1.y = 0;

 positionRg2.x = 0;
 positionRg2.y = surface->h/2 - 50;

 positionRg3.x = 0;
 positionRg3.y = surface->h - 50;

 positionlf1.x = surface->w - 1;
 positionlf1.y = 0;

 positionlf2.x = surface->w - 1;
 positionlf2.y = surface->h/2 - 50;

 positionlf3.x = surface->w - 1;
 positionlf3.y = surface->h - 50;

 positionTop1.x  = 1;
 positionTop1.y  = 0;

 positionTop2.x = surface->w - 51;
 positionTop2.y = 0;

 positionBas2.x  = surface->w - 51;
 positionBas2.y  = surface->h - 1;

 positionBas1.x = 1;
 positionBas1.y = surface->h - 1;

 positionRack1.x = surface->w/2 - rack1->w/2;
 positionRack1.y = surface->h - rack1->h -3 - ball->h;

 positionRack2.x = surface->w/2 - rack2->w/2;
 positionRack2.y =  3 + ball->h;

 positionBall.x = surface->w/2 -ball->w/2;
 positionBall.y = positionRack1.y - ball->h;

/* Data */                                         
 RSection1 = 1*rack1->w/5;     
 RSection2 = 2*rack1->w/5;     
 RSection3 = 3*rack1->w/5;     
 RSection4 = 4*rack1->w/5;     
                                         
 tolerence1 = ball->w/2;
 tolerence2 = ball->w/2;

 top  = rack2->h + positionRack2.y;
 low  = positionRack1.y;
 right = surface->w - ball->w;
	
/* Keyboard & Mouse */
SDL_WM_SetCaption("Player 1 ( P1 )",NULL);
SDL_EnableKeyRepeat(Bspeed, 0);
SDL_ShowCursor(0);

/*** Threads & Semaphores ***/
semWrite = SDL_CreateSemaphore(1);
semRead  = SDL_CreateSemaphore(0);

/* Send : positionRack1 & positionBall / Receive : positionRack2 */
thread1 = SDL_CreateThread(net,NULL); 

/* Display */
thread2 = SDL_CreateThread(display,NULL);

while(play)
{
    /* SDL_MUSTLOCK(surface); */
    SDL_WaitEvent(&event);
    switch(event.type)
    {
 	case SDL_QUIT: play = 0;
 	break;

        case SDL_KEYDOWN:

	                switch(event.key.keysym.sym)
		        {

			 case SDLK_RIGHT :     if( limit_rack1  < surface->w -5)
						 positionRack1.x += Rspeed;
		         break;

			 case SDLK_LEFT  :      if(positionRack1.x > 3)
						  positionRack1.x -= Rspeed;
			 break;

			 case SDLK_SPACE: 	SDL_SetTimer(Bspeed ,MoveBall);
			 break;
			
			 case SDLK_q:	play = 0;
                         break;

			 default:
			 break;
		      }

      break;
      default :
      break;
    }
}


    SDL_SetTimer(stopBall, NULL);

    SDL_KillThread(thread2);
    SDL_KillThread(thread1);
    SDL_DestroySemaphore(semWrite);
    SDL_DestroySemaphore(semRead);

    /* free the memory */
    SDL_FreeSurface(rack1);
    SDL_FreeSurface(rack2);
    SDL_FreeSurface(ball);
    SDL_FreeSurface(surface);
    SDL_FreeSurface(table);
    SDL_FreeSurface(time);
    SDL_FreeSurface(score);
    SDL_FreeSurface(title);

    TTF_CloseFont(police);

    Mix_CloseAudio();
    Mix_FreeChunk(hit);
    Mix_FreeChunk(mur);
    
    Mix_Quit();
    TTF_Quit();
    SDL_Quit();

    /* Shutdown only reception or transmission */
    shutdown(csock, SHUT_RDWR);
    closesocket(ssock);

    return EXIT_SUCCESS;
}
