# include "defs.h"

extern SDL_Surface *screen;
extern SDL_Surface *surface;
extern SDL_Surface *table;
extern SDL_Surface *center;

extern SDL_Surface *leftlm1;
extern SDL_Surface *leftlm2;
extern SDL_Surface *leftlm3;

extern SDL_Surface *rightlm1;
extern SDL_Surface *rightlm2;
extern SDL_Surface *rightlm3;

extern SDL_Surface *top1;
extern SDL_Surface *top2;
extern SDL_Surface *bas1;
extern SDL_Surface *bas2;

extern SDL_Surface *rack1;
extern SDL_Surface *rack2;
extern SDL_Surface *ball;
extern SDL_Surface *time;
extern SDL_Surface *score;
extern SDL_Surface *title;

extern TTF_Font *police;
SDL_Color green = {0,255,0};


int net(void * data)
{

 while(play)
 {
  SDL_SemWait(semWrite);/* ++++++++++++++++++++++++++++++++ */

  	send(csock, (int *)&p1, sizeof(int), 0);
  	send(csock, (int *)&p2, sizeof(int), 0);
  	send(csock, (SDL_Rect *)&positionBall,  sizeof(SDL_Rect), 0);
  	send(csock, (SDL_Rect *)&positionRack1, sizeof(SDL_Rect), 0);
  	recv(csock, (SDL_Rect *)&positionRack2, sizeof(SDL_Rect), 0);

  SDL_SemPost(semRead);/* ++++++++++++++++++++++++++++++++ */

 }
} 

/******************************************/

int display(void * data)
{
 int ticks, sec, min, hour;
 char clock[10], p1_p2[20];

 title  = TTF_RenderText_Blended(police, "SPPONG 0.2", green);
 positionTte.x = table->w/2 - title->w/2;
 positionTte.y = table->h/2 - title->h/2;
 
 while(play)
 {
  ticks = SDL_GetTicks()/1000; 
  hour = ticks/3600;
  min  = (ticks%3600)/60;
  sec  = (ticks%3600)%60;
  
  sprintf(clock,"%02d:%02d:%02d",hour,min,sec);
  time = TTF_RenderText_Blended(police, clock, green); 

  positionTme.x = table->w - time->w -10;
  positionTme.y = table->h/2 - time->h/2;

  /****************************************/

  SDL_FillRect(surface, NULL, SDL_MapRGBA(surface ->format, 0, 0, 0, 0));
  SDL_FillRect(table,   NULL, SDL_MapRGBA(table ->format,   0, 0, 0, 0));
  SDL_FillRect(center,  NULL, SDL_MapRGBA(center ->format, 15, 15, 15, 0));

  SDL_FillRect(leftlm1, NULL, SDL_MapRGBA(leftlm1 ->format, 15, 15, 15, 0));
  SDL_FillRect(leftlm2, NULL, SDL_MapRGBA(leftlm2 ->format, 15, 15, 15, 0));
  SDL_FillRect(leftlm3, NULL, SDL_MapRGBA(leftlm3 ->format, 15, 15, 15, 0));

  SDL_FillRect(rightlm1,NULL, SDL_MapRGBA(rightlm1 ->format, 15, 15, 15, 0));
  SDL_FillRect(rightlm2,NULL, SDL_MapRGBA(rightlm2 ->format, 15, 15, 15, 0));
  SDL_FillRect(rightlm3,NULL, SDL_MapRGBA(rightlm3 ->format, 15, 15, 15, 0));

  SDL_FillRect(top1,NULL, SDL_MapRGBA(top1 ->format, 15, 15, 15, 0));
  SDL_FillRect(top2,NULL, SDL_MapRGBA(top2 ->format, 15, 15, 15, 0));
  SDL_FillRect(bas1,NULL, SDL_MapRGBA(bas1 ->format, 15, 15, 15, 0));
  SDL_FillRect(bas2,NULL, SDL_MapRGBA(bas2 ->format, 15, 15, 15, 0));
   
  SDL_BlitSurface(rightlm1,   NULL, surface, &positionRg1);
  SDL_BlitSurface(rightlm2,   NULL, surface, &positionRg2);
  SDL_BlitSurface(rightlm3,   NULL, surface, &positionRg3);

  SDL_BlitSurface(leftlm1,    NULL, surface, &positionlf1);
  SDL_BlitSurface(leftlm2,    NULL, surface, &positionlf2);
  SDL_BlitSurface(leftlm3,    NULL, surface, &positionlf3);

  SDL_BlitSurface(top1,       NULL, surface, &positionTop1);
  SDL_BlitSurface(top2,       NULL, surface, &positionTop2);
  SDL_BlitSurface(bas1,       NULL, surface, &positionBas1);
  SDL_BlitSurface(bas2,       NULL, surface, &positionBas2);
  SDL_BlitSurface(center,     NULL, surface, &positionCtr); 

  SDL_BlitSurface(title,      NULL, table,   &positionTte);
  SDL_BlitSurface(time,	      NULL, table,   &positionTme);
 
  SDL_SemTryWait(semRead); /* +++++++++++++++++++++++++++++++ */

  SDL_BlitSurface(ball,       NULL, surface, &positionBall); 
  SDL_BlitSurface(rack1,      NULL, surface, &positionRack1);
  SDL_BlitSurface(rack2,      NULL, surface, &positionRack2);

  sprintf(p1_p2,"P1 - P2 : %2d - %2d",p1,p2);
  score = TTF_RenderText_Blended(police, p1_p2, green);
  positionScr.x = 10;
  positionScr.y = table->h/2 - score->h/2;   

  SDL_SemPost(semWrite); /* +++++++++++++++++++++++++++++++ */

  SDL_BlitSurface(score,      NULL, table,   &positionScr);
  SDL_BlitSurface(table,      NULL, screen,  &positionTab); 	      
  SDL_BlitSurface(surface,    NULL, screen,  &positionSur);
  SDL_Flip(screen);
 }
} 
